Allow copy/paste of columns between tables also when columns do not have the same order
Status: Feedback

Priority: Normal

Assignee:

Category: Attribute table

Pull Request or Patch supplied:No Resolution:

Easy fix?: No Copied to github as #: 20824

Description

new description:

#12722-6

old description:

I have a number of projects where I am combining several tables together by copying and pasting data between tables. The source table

has two string columns and the destination table has two string columns and a integer column. The string columns are all the same length

of 80 characters. Sometimes the paste will result in all of the destination columns of the newly pasted records being nulled in the

destination table.

I have not been able to identify a consistent pattern of this occuring so it is difficult or impossible to reproduce. I recall that in an earlier

version of Qgis the table paste was recoded to null out some columns to deal with errors of data conversion.

History

#1 - 2015-05-08 08:26 AM - Giovanni Manghi

- Status changed from Open to Feedback

- Category set to Vectors

the columns do have the same datatype and name?

#2 - 2015-05-26 10:40 AM - Saber Razmjooei

- Status changed from Feedback to Closed

Not possible to reproduce. The ticket is closed, but feel free to reopen and provide some data to reproduce the problem.

#3 - 2015-05-26 12:05 PM - Giovanni Manghi

- Resolution set to not reproducable

#4 - 2015-09-30 06:35 AM - Harrissou Santanna

- Status changed from Closed to Reopened

I think I reproduce it.

I have a PostGIS table A that I "saved as" a shapefile B, with "only selected features" option checked

My new layer B has the expected features with their attributes (field name is identical and values are well retrieved).

Now, copy paste another feature from the source layer A into B. This new feature has NULL attributes.
IMHO, Should be set as blocker.

master fea4ed9

#5 - 2015-10-03 07:37 PM - Patrick Dunford

I use file based layers and I see it all the time.

I have been on the case of cross table paste issues for some time. It used to be when pasting from one table to another you would get crashes. My

understanding was this was worked around at some point by pasting nulls instead (in other words you can still paste a visible feature from one table to

another, but any of the table values will be cleared when pasting).

Whether this is still the case that those columns are nulled on paste, I do not know. All my tables are using string values and it seemed to me while pasting

other types of values could cause conversion errors, pasting one string to another shouldn't cause a problem.

#6 - 2016-01-01 08:21 PM - Patrick Dunford

There has been an improvement with 2.12 in seeing that pastes work most of the time provided the source table columns are in the same order in the

destination table

e.g. source columns are A and B, destination columns are A B and C, the source columns get pasted correctly into the destination table.

However I believe it should also work for the scenario where the columns have the same names but are in a different order.

e.g. if the source is A B and the destination is A D E B C then all the columns are pasted as nulls. It should be possible to find the column of the same name

and paste into it if the type and size match.

#7 - 2016-01-03 05:00 AM - Giovanni Manghi

- Status changed from Reopened to Feedback

- Resolution deleted (not reproducable)

However I believe it should also work for the scenario where the columns have the same names but are in a different order.

but this would be a feature request, agree?

#8 - 2016-05-23 10:00 AM - Giovanni Manghi

- Category changed from Vectors to Attribute table

- Tracker changed from Bug report to Feature request

- Subject changed from Paste from one table to another results in nulls in all fields to Allow copy/paste of columns between tables also when columns do 

not have the same order

- Operating System deleted (Windows)

- OS version deleted (8.1 (6.3 9600))

#9 - 2017-05-01 12:47 AM - Giovanni Manghi

- Easy fix? set to No

#10 - 2017-08-08 12:44 AM - Jürgen Fischer

- Description updated
